osl::eval::ml::PawnPtypeOPtypeO Class Reference

`#include <minorPiece.h>`

## Public Types

enum | { ONE_DIM = 1024 , DIM = ONE_DIM * EvalStages }

## Static Public Member Functions

static void | setUp (const Weights &weights)
static MultiInt | eval (const NumEffectState &state)
template<Player P>
static MultiInt | evalWithUpdate (const NumEffectState &state, Move moved, const CArray2d< int, 2, 9 > &pawns, const MultiInt &last_value)

## Static Private Member Functions

static int | index (Player P, PtypeO up, PtypeO up_up)
static int | indexY (Player P, PtypeO up, PtypeO up_up, int y)

## Static Private Attributes

static CArray< MultiInt, 1024 > | table
static CArray< MultiInt, 9216 > | y_table

## Friends

class | PawnPtypeOPtypeOY

## Detailed Description

Definition at line 850 of file minorPiece.h.

## Member Enumeration Documentation

## anonymous enum

anonymous enum

Enumerator
ONE_DIM |
DIM |

Definition at line 854 of file minorPiece.h.

## Member Function Documentation

## eval()

MultiInt osl::eval::ml::PawnPtypeOPtypeO::eval | ( | const NumEffectState & | state | ) |

static

Definition at line 691 of file minorPiece.cc.

References osl::BLACK, osl::Board_Table, index(), indexY(), osl::Piece::isOnBoard(), osl::Square::isOnBoard(), osl::Piece::isPromoted(), osl::Piece::owner(), osl::SimpleState::pieceAt(), osl::SimpleState::pieceOf(), osl::Piece::ptypeO(), osl::Piece::square(), table, osl::U, osl::Square::y(), and y_table.

Referenced by osl::eval::ml::OpenMidEndingEval::OpenMidEndingEval().

## evalWithUpdate()

template<osl::Player P>

template MultiInt osl::eval::ml::PawnPtypeOPtypeO::evalWithUpdate< WHITE > | ( | const NumEffectState & | state,
|  | Move | moved,
|  | const CArray2d< int, 2, 9 > & | pawns,
|  | const MultiInt & | last_value )

static

Definition at line 726 of file minorPiece.cc.

References osl::alt(), osl::BLACK, osl::captured(), osl::Move::capturePtype(), osl::Move::capturePtypeOSafe(), osl::Move::from(), index(), indexY(), osl::Move::isDrop(), osl::Square::isOnBoard(), osl::Move::oldPtype(), osl::Move::oldPtypeO(), osl::PAWN, osl::SimpleState::pieceAt(), osl::Move::player(), osl::Move::ptype(), osl::Move::ptypeO(), osl::Piece::ptypeO(), osl::PTYPEO_EMPTY, table, osl::Move::to(), osl::WHITE, osl::Square::x(), osl::Square::y(), and y_table.

## index()

int osl::eval::ml::PawnPtypeOPtypeO::index | ( | Player | P,
|  | PtypeO | up,
|  | PtypeO | up_up )

inline static private

Definition at line 863 of file minorPiece.h.

References osl::altIfPiece(), osl::PTYPEO_MIN, and osl::WHITE.

Referenced by eval(), evalWithUpdate(), and indexY().

## indexY()

int osl::eval::ml::PawnPtypeOPtypeO::indexY | ( | Player | P,
|  | PtypeO | up,
|  | PtypeO | up_up,
|  | int | y )

inline static private

Definition at line 872 of file minorPiece.h.

References osl::BLACK, and index().

Referenced by eval(), and evalWithUpdate().

## setUp()

void osl::eval::ml::PawnPtypeOPtypeO::setUp | ( | const Weights & | weights | ) |

static

Definition at line 671 of file minorPiece.cc.

References osl::NStages, ONE_DIM, table, and osl::eval::ml::Weights::value().

## Friends And Related Symbol Documentation

## PawnPtypeOPtypeOY

friend class PawnPtypeOPtypeOY

friend

Definition at line 852 of file minorPiece.h.

References PawnPtypeOPtypeOY.

Referenced by PawnPtypeOPtypeOY.

## Member Data Documentation

## table

osl::CArray< MultiInt, 1024 > osl::eval::ml::PawnPtypeOPtypeO::table

static private

Definition at line 877 of file minorPiece.h.

Referenced by eval(), evalWithUpdate(), and setUp().

## y_table

osl::CArray< MultiInt, 9216 > osl::eval::ml::PawnPtypeOPtypeO::y_table

static private

Definition at line 878 of file minorPiece.h.

Referenced by eval(), evalWithUpdate(), and osl::eval::ml::PawnPtypeOPtypeOY::setUp().

The documentation for this class was generated from the following files:

- minorPiece.h
- minorPiece.cc